////////////////////////////////////////////////////////////////////////////
//	write your comments to : loadall@hotmail.com
//  chat with the author (loadall) on IRCNet, channel #coders
////////////////////////////////////////////////////////////////////////////
#include "system.hpp"
#include "pak.hpp"

void LZW_encode(char* szDest, char* szSrc)
{
	int srcSize, destSize, codeSize, currChar, bitsOffset, destDword;
	char* lpSrcBase, *lpDestBase, *lpAlphabet, *lpFreeCode, *lpMaxCode;
	char* lpCurrCode, *lpLastBrother, *lpSrc, *lpSrcMax, *lpDest;
#define MAX_CODE_SIZE	0xc
#define CODE_EOI	  0x100
typedef struct {
	char* Alph_lpChildren;
	char* Alph_lpBrother;
	int Alph_character;
	int Alph_code;
} AlphCode_t;
	_asm {
	pushad
	call	WWinit
	WW1000:
	mov	eax, ebx
	add	eax, ((CODE_EOI + 1) * (size AlphCode_t))
	mov	[lpFreeCode], eax
	mov	eax, ebx
	add	eax, (0200h * (size AlphCode_t))
	mov	[lpMaxCode], eax
	mov	[codeSize], 9
	xor	eax, eax
	xor	ecx, ecx
	mov	edx, ebx
	WW1100:
	mov	[edx.Alph_lpChildren], eax
	mov	[edx.Alph_lpBrother], eax
	mov	[edx.Alph_character], ecx
	mov	[edx.Alph_code], ecx
	add	edx, (size AlphCode_t)
	inc	cl
	jnz	WW1100
	call	WWgetChar
	mov	edx, eax
	shl	edx, 4
	add	edx, ebx
	mov	[lpCurrCode], edx
	cmp	eax, CODE_EOI
	je	WW9000
	WW2000:
	call	WWgetChar
	cmp	eax, CODE_EOI
	je	WW9000
	mov	[currChar], eax
	mov	esi, [lpCurrCode]
	mov	[lpLastBrother], 0
	mov	esi, [esi.Alph_lpChildren]
	WW2100:
	cmp	esi, 0
	je	WW3000
	mov	edx, esi
	mov	[lpLastBrother], esi
	mov	ecx, [esi.Alph_character]
	mov	esi, [esi.Alph_lpBrother]
	cmp	eax, ecx
	jne	WW2100
	mov	[lpCurrCode], edx
	jmp	WW2000
	WW3000:
	mov	esi, [lpCurrCode]
	mov	eax, [esi.Alph_code]
	call	wwsetCode
	mov	eax, [currChar]
	shl	eax, 4
	add	eax, ebx
	mov	[lpCurrCode], eax
	mov	edi, [lpFreeCode]
	mov	ecx, [lpMaxCode]
	cmp	edi, ecx
	jnb	WW4000
	WW3100:
	mov	edx, [lpLastBrother]
	cmp	edx, 0
	je	WW3300
	mov	[edx.Alph_lpBrother], edi
	WW3200:
	add	[lpFreeCode], (size AlphCode_t)
	mov	eax, [currChar]
	mov	[edi.Alph_character], eax
	mov	eax, edi
	sub	eax, ebx
	shr	eax, 4
	mov	[edi.Alph_code], eax
	xor	eax, eax
	mov	[edi.Alph_lpBrother], eax
	mov	[edi.Alph_lpChildren], eax
	jmp	WW2000
	WW3300:
	mov	[esi.Alph_lpChildren], edi
	jmp	WW3200
	WW4000:
	mov	ecx, [codeSize]
	cmp	ecx, MAX_CODE_SIZE
	jnb	WW4100
	inc	[codeSize]
	mov	eax, [lpMaxCode]
	sub	eax, ebx
	add	eax, eax
	add	eax, ebx
	mov	[lpMaxCode], eax
	jmp	WW3100
	WW4100:
	mov	eax, [currChar]
	call	WWsetCode
	jmp	WW1000

	WWinit:
	lea	eax, [srcSize]
	push	eax
	push	[szSrc]
	call	Sys_FileLoad
//	add		esp, 8
	mov	[lpSrcBase], eax
	mov	[lpSrc], eax
	add	eax, [srcSize]
	mov	[lpSrcMax], eax
	push	[srcSize]
	call	Sys_MemAlloc
//	add		esp, 4
	mov	[lpDestBase], eax
	mov	[lpDest], eax
	push	 ((size AlphCode_t) * (1 shl MAX_CODE_SIZE))
	call	Sys_MemAlloc
//	add		esp, 4
	mov	[lpAlphabet], eax
	xchg	eax,ebx
	xor	eax, eax
	mov	[destSize], eax
	mov	[bitsOffset], eax
	mov	[destDword], eax
	retn

	WWcleanUp:
	mov	cl, 4
	WW12000:
	mov	eax, CODE_EOI
	call	WWsetCode
	dec	cl
	jnz	WW12000
	push	[lpAlphabet]		
	call	Sys_MemFree
//	add		esp, 4
	push	[lpSrcBase]
	call	Sys_MemFree
//	add		esp, 4
	push	[szDest]
	call	Sys_FileCreate
//	add		esp, 4
	xchg	eax, ebx
	lea	eax ,[srcSize]
	push	4
	push	eax
	push	ebx
	push	[szDest]
	call	Sys_FileWrite
//	add		esp, 010h
	push	[destSize]
	push	[lpDestBase]
	push	ebx
	push	[szDest]
	call	Sys_FileWrite
//	add		esp, 010h
	push	ebx
	call	Sys_FileClose
//	add		esp, 4
	push	[lpDestBase]
	call	Sys_MemFree
//	add		esp, 4
	retn
	
	WWgetChar:
	push	ecx
	push	esi
	mov	esi, [lpSrc]
	mov	ecx, [lpSrcMax]
	cmp	esi, ecx
	jnb	WW10100
	mov	eax, [esi]
	inc	esi
	and	eax, 0ffh
	mov	[lpSrc], esi
	pop	esi
	pop	ecx
	retn
	WW10100:
	mov	eax, CODE_EOI
	pop	esi
	pop	ecx
	retn

	WWsetCode:
	push	eax
	push	ebx
	push	ecx
	push	edx
	push	edi
	mov	ebx, [codeSize]
	mov	ecx, [bitsOffset]
	mov	edi, [destDword]
	WW11000:
	mov	edx, eax
	shr	eax, 1
	and	edx, 1
	shl	edx, cl
	inc	ecx
	or	edi, edx
	test	ecx, 020h
	jnz	WW11100
	WW11050:
	dec	ebx
	jnz	WW11000
	mov	[destDword], edi
	mov	[bitsOffset], ecx
	pop	edi
	pop	edx
	pop	ecx
	pop	ebx
	pop	eax
	retn
	WW11100:
	mov	ecx, [lpDest]
	mov	edx, [destSize]
	mov	[ecx], edi
	add	ecx, 4
	add	edx, 4
	mov	[lpDest], ecx
	mov	[destSize], edx
	xor	edi, edi
	xor	ecx, ecx
	jmp	WW11050

	WW9000:
	call	WWcleanUp
	popad
	}
}
